/*
 * Copyright 2009 © David Casperson
 * May be used freely, provided that this notice is preserved.
 */
// This file is really -*- c++ -*-
#if !defined(stopwatch_INCLUDED)

#include "system_time.h"
#include <iosfwd>


class StopWatch                 // The classic three button stop-watch
{
public:
    StopWatch() ;

    // The three buttons.
    StopWatch& start() ;
    StopWatch& stop() ;
    StopWatch& reset() ;

    // and queries
    double elapsed() const ;
    bool is_running() const ;


private:
    void handleButton(system_time const&, bool reset, bool running) ;
    
    system_time epoch ;             // last time at which a button was
                                    // pressed.
    
    double total ;              // total elapsed time between the last
                                // press of reset() and the last press
                                // of stop().
    
    bool running ;               // true iff start() was pressed more
                                 // recently than stop().
} ;

std::ostream& operator<< (std::ostream& o, const StopWatch& s) ;

#define stopwatch_INCLUDED
#endif// !defined(stopwatch_INCLUDED)
